/*
 * 运费按区域
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProductFareAreasController : BaseController
    {
        public ProductFareAreasController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 运费按区域列表

        /// <summary>
        /// 根据条件查询运费按区域列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProductFareAreas data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            string Condition = "";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询运费按区域列表

        /// <summary>
        /// 运费按区域列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProductFareAreas data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductFareAreas", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加运费按区域

        /// <summary>
        /// 增加或修改运费按区域信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 增加运费按区域

        /// <summary>
        /// 增加或修改运费按区域信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProductFareAreas data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Areas", data.Areas); //地区
            Fields.Add("FirstAmount", data.FirstAmount); //首件数量
            Fields.Add("FirstFee", data.FirstFee); //首件费用
            Fields.Add("MoreAmount", data.MoreAmount); //续件数量
            Fields.Add("MoreFee", data.MoreFee); //续件费用

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ProductFareAreas", Fields, 0);
            AddSysLog(data.Id.ToString(), "ProductFareAreas", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改运费按区域

        /// <summary>
        /// 增加或修改运费按区域信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            ProductFareAreas editData = db.ProductFareAreas.FirstOrDefault(m => m.Id == Id) ?? new ProductFareAreas();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改运费按区域

        /// <summary>
        /// 增加或修改运费按区域信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProductFareAreas data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Areas", data.Areas); //地区
            Fields.Add("FirstAmount", data.FirstAmount); //首件数量
            Fields.Add("FirstFee", data.FirstFee); //首件费用
            Fields.Add("MoreAmount", data.MoreAmount); //续件数量
            Fields.Add("MoreFee", data.MoreFee); //续件费用

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductFareAreas", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "ProductFareAreas", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除运费按区域信息

        /// <summary>
        /// 删除运费按区域信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductFareAreas", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("ProductFareAreas", id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductFareAreas", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductFareAreas", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductFareAreas", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductFareAreas", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ProductFareAreas", Sort, Id);

            AddSysLog(Id.ToString(), "ProductFareAreas", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.ProductFareAreas.Add(new ProductFareAreas()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProductFareAreas", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProductFareAreas data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductFareAreas", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProductFareAreas", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
